#include <Arduino.h>
#include <LiquidCrystal_I2C.h>

#define MOTOR 3

#define RED 11
#define GREEN 10
#define BLUE 9


#define COMMONINT 2
#define DOWNLEFT 13
#define UPRIGHT 7
#define SEL 8
#define BACK 12

#define MIN 0
#define MID 128
#define MAX 255



// #define MOTOR 3

// int i;
// int red, green, blue, R, G, B, tranzition_loop;
int R, G, B;

const int buttons[] = {DOWNLEFT, UPRIGHT, SEL, BACK};
unsigned long time;
unsigned long time1 = 0;
String menu[3][5] = {{"Plain Color", "Red", "Green", "Blue", "0"},
                    {"Light Patterns", "Rainbow", "Random", "Gamer lights", "Blink"},
                    {"Speed", "Fast", "Faster", "Disco Time", "0"}};

bool values[3][5] = {{false, false, false, false, false},
                    {false, false, false, false, false},
                    {false, false, false, false, false}};


int amount[] = {3, 4, 3};

int position;
int tempPosition;
int cursor;
int tempCursor;
int selection;
int side;

bool lcdClear;

LiquidCrystal_I2C lcd(0x27, 16, 2);


void setColor(int R, int G, int B)
{
    R = 255 - R;
    G = 255 - G;
    B = 255 - B;
    analogWrite(RED, R);
    analogWrite(GREEN, G);
    analogWrite(BLUE, B);
}

void setRED(int R)
{
    R = 255 - R;
    analogWrite(RED, R);
}
void setGREEN(int G)
{
    G = 255 - G;
    analogWrite(GREEN, G);
}
void setBLUE(int B)
{
    B = 255 - B;
    analogWrite(BLUE, B);
}



void loopColorContinuous() {
    if(R == MAX && G < MAX)
        G++;
    if(G == MAX && R <= MAX && R > MIN)
        R--;
    if(G == MAX && R == MIN && B < MAX)
        B++;
    if(G > MIN && B == MAX)
        G--;
    if(B == MAX && G == MIN && R < MAX)
        R++;
    if(B > MIN && R == MAX)
        B--;
    setColor(R, G, B);
    delay(10);
  }

  void gamerMode() {
    if(R == MAX && B < MAX)
        B++;
    if(B == MAX && R <= MAX && R > MIN)
        R--;
    if(R == MIN && B > MIN)
        B--;
    if(R < MAX && B == MIN)
        R++;
    setColor(R, G, B);
    delay(10);
  }

//
//void setColorBoth(int red, int green, int blue) {
//  setColorMain(red, green, blue);
//  setColorComp(red, green, blue);
// }
//
//

void interruptSet() {
    pinMode(COMMONINT, OUTPUT);
    digitalWrite(COMMONINT, LOW);


    for (int i = 0; i < 4; i++) {
        pinMode(buttons[i], INPUT_PULLUP);
    }
}




void variablesSetup() {
    time = 0;
    R = 0;
    G = 0;
    B = 0;

    position = 0;
    tempPosition = 1;
    cursor = 0;
    selection = 0;
    side = 0;

    lcdClear = false;
}

void ledSetup() {
    pinMode(RED, OUTPUT);
    pinMode(GREEN, OUTPUT);
    pinMode(BLUE, OUTPUT);

    setColor(R, G, B);
}

void buttonSetup() {
    pinMode(COMMONINT, INPUT_PULLUP);

    for (int i = 0; i < 4; i++) {
        pinMode(buttons[i], OUTPUT);
        digitalWrite(buttons[i], LOW);
    }
}

void Blink() {
    setColor(255, 0, 0);
    delay(300);
    setColor(255, 128, 0);
    delay(300);
    setColor(255, 255, 0);
    delay(300);
    setColor(128, 255, 0);
    delay(300);
    setColor(0, 255, 0);
    delay(300);
setColor(0, 255, 128);
delay(300);
setColor(0, 255, 255);
delay(300);
setColor(0, 128, 255);
delay(300);
setColor(0, 0, 255);
delay(300);
setColor(128, 0, 255);
delay(300);
setColor(255, 0, 255);
delay(300);
setColor(255, 0, 128);
delay(300);
}

void buttonPress()
{
    if(millis() - time > 300) {
        time = millis();

        interruptSet();

        if (!digitalRead(DOWNLEFT)) {
            if(selection == 0) {
                position = position == 2 ? 0 : position + 1;
                tempPosition = position == 2 ? 0 : position + 1;
                lcdClear = true;


            } else if(selection == 1){
                cursor = cursor == amount[position] ? 1 : cursor + 1;
                tempCursor = cursor == amount[position] ? 1 : cursor + 1;
                lcdClear = true;
            } else if(selection == 2) {
                side = 0;
            }
        } else if (!digitalRead(UPRIGHT)) {
            if(selection == 0) {
                tempPosition = position;
                position = position == 0 ? 2 : position - 1;
                lcdClear = true;
            } else if (selection == 1) {
                tempCursor = cursor;
                cursor = cursor == 1 ? amount[position] : cursor - 1;
                lcdClear = true;
            } else if(selection == 2) {
                side = 1;
            }

        } else if (!digitalRead(SEL)) {
            selection++;
            if(selection == 0) {

            } else if (selection == 1) {
                cursor = 1;
                tempCursor = 2;
            } else if (selection == 2) {
                side = 0;
            } else if (selection == 3) {
                if(side == 0) {
                    values[position][cursor] = true;
                    if (position == 0) {
                        if(cursor == 1) {
                        setRED(255);
                        } else if(cursor == 2) {
                        setGREEN(255);
                        } else if(cursor == 3) {
                        setBLUE(255);
                        }
                    } else if (position == 1) {
                        if(cursor == 1) {
                            R = 255;
                            G = 0;
                            B = 0;
                        } else if(cursor == 2) {
                            if(millis() - time > 300) {
                                setColor(rand() % 256, rand() % 256, rand() % 256);
                                time = millis();
                            }
                        } else if(cursor == 3) {
                            R = 255;
                            G = 0;
                            B = 0;
                        }
                    } else if (position == 2) {
                        if(cursor == 1) {
                            analogWrite(MOTOR, 70);
                        } else if(cursor == 2) {
                            analogWrite(MOTOR, 150);
                        } else if(cursor == 3) {
                            analogWrite(MOTOR, 255);
                        }
                    }
                } else if (side == 1) {
                    values[position][cursor] = false;
                    if (position == 0) {
                        if(cursor == 1) {
                        setRED(0);
                        } else if(cursor == 2) {
                        setGREEN(0);
                        } else if(cursor == 3) {
                        setBLUE(0);
                        }
                    } else if (position == 1) {
                        if(cursor == 1) {
                            R = 0;
                            G = 0;
                            B = 0;
                            setColor(R, G, B);
                        } else if(cursor == 2) {

                        } else if(cursor == 3) {

                        }
                    } else if (position == 2) {
                        if(cursor == 1) {
                            analogWrite(MOTOR, 0);
                        } else if(cursor == 2) {
                            analogWrite(MOTOR, 0);
                        } else if(cursor == 3) {
                            analogWrite(MOTOR, 0);
                        }
                    }
                }
                selection = 0;
                cursor = 0;
                tempCursor = 1;
                position = 0;
                tempPosition = 1;
                side = 0;
            }

            lcdClear = true;
        } else if (!digitalRead(BACK)) {
            Serial.println(BACK);
        }
        buttonSetup();
    }
}

void setup()
{

    lcd.init();
  // turn on the backlight
    lcd.backlight();
    lcd.noBlink();

    // RGB setup

    buttonSetup();
    attachInterrupt(digitalPinToInterrupt(COMMONINT), buttonPress, 2);

    variablesSetup();
    ledSetup();
    pinMode(MOTOR, OUTPUT);
    Serial.begin(9600);
    Serial.println("buna");

// //    Serial.println(RED);
// //    pinMode(GREEN, OUTPUT);
// //    pinMode(BLUE, OUTPUT);
// //    pinMode(WHITE, OUTPUT);

//     //pinMode(MOTOR, OUTPUT);
//   R = 255;
//   G = 0;
//   B = 0;
//   tranzition_loop = 0;
}

void loop()
{
    if(lcdClear) {
        lcd.clear();
        lcdClear = false;
    }

    if(selection == 0) {
        lcd.setCursor(0,0);
        lcd.print("->" + menu[position][cursor]);
        lcd.setCursor(0,1);
        lcd.print("  " + menu[tempPosition][cursor]);
    } else if(selection == 1) {
        lcd.setCursor(0,0);
        lcd.print("->" + menu[position][cursor]);
        lcd.setCursor(0,1);
        lcd.print("  " + menu[position][tempCursor]);
    } else if(selection == 2) {
        lcd.setCursor(0,0);
        lcd.print("Sel " + menu[position][cursor] + " ?");
        lcd.setCursor(0,1);
         if(side == 0) {
            lcd.print("  ->yes     no  ");
        } else if(side == 1) {
            lcd.print("    yes   ->no  ");
        }
    }

    Serial.println(values[1][1]);
    if(values[1][1]) {
        loopColorContinuous();
    } else if (values[1][3]) {
        gamerMode();
    }

}


// //

//
//void setColorComp(int red, int green, int blue)
//{
//  analogWrite(RED_COMP, red);
//  analogWrite(GREEN_COMP, green);
//  analogWrite(BLUE_COMP, blue);  
//}


